searchNodes=[{"doc":"LiveState LiveState is a library to manage application state for a non elixir hosted application. A LiveState application roughly follows the pattern of Event Driven Architecture. Rather than requests and reponses, in a LiveState application your client emits Events and receives changes to state (and possibly additional events). This allows your client code to concern itself only with how to render the appropriate state and dispatch the appropriate events. The application state must be serializable as JSON. Currently the entire state is returned on each event, but future versions will implement JSON patch to send efficient updates. Usage LiveState uses Phoenix Channels to implement communication from the client. To use it, you'll want to start with a channel that uses the LiveState.Channel behaviour. You'll also want to use a client library to connect to a LiveState application. Currently this exists for javascript in the phx-live-state","ref":"LiveState.html","title":"LiveState","type":"module"},{"doc":"To build a LiveState application, you'll first want to add a channel that implements this behaviour.","ref":"LiveState.Channel.html","title":"LiveState.Channel","type":"behaviour"},{"doc":"Called from join to authorize the connection. Return {:ok, socket} to authorize or {:error, reason} to deny. Default implementation returns {:ok, socket}","ref":"LiveState.Channel.html#c:authorize/3","title":"LiveState.Channel.authorize/3","type":"callback"},{"doc":"Receives an event an payload from the client and current state. Returns the new state along with (optionally) a single or list of LiveState.Event to dispatch to client","ref":"LiveState.Channel.html#c:handle_event/3","title":"LiveState.Channel.handle_event/3","type":"callback"},{"doc":"","ref":"LiveState.Channel.html#c:handle_event/4","title":"LiveState.Channel.handle_event/4","type":"callback"},{"doc":"Receives pubsub message and current state. Returns new state","ref":"LiveState.Channel.html#c:handle_message/2","title":"LiveState.Channel.handle_message/2","type":"callback"},{"doc":"Returns the initial application state. Called just after connection","ref":"LiveState.Channel.html#c:init/3","title":"LiveState.Channel.init/3","type":"callback"},{"doc":"The key on assigns to hold application state. Defaults to :state .","ref":"LiveState.Channel.html#c:state_key/0","title":"LiveState.Channel.state_key/0","type":"callback"},{"doc":"The key on assigns to hold application state version. Defaults to :version .","ref":"LiveState.Channel.html#c:state_version_key/0","title":"LiveState.Channel.state_version_key/0","type":"callback"},{"doc":"Represents a CustomEvent to be returned from a reply and dispatched on the client.","ref":"LiveState.Event.html","title":"LiveState.Event","type":"module"},{"doc":"","ref":"LiveState.Test.AuthorizedChannel.html","title":"LiveState.Test.AuthorizedChannel","type":"module"},{"doc":"Callback implementation for LiveState.Channel.authorize/3 .","ref":"LiveState.Test.AuthorizedChannel.html#authorize/3","title":"LiveState.Test.AuthorizedChannel.authorize/3","type":"function"},{"doc":"","ref":"LiveState.Test.AuthorizedChannel.html#child_spec/1","title":"LiveState.Test.AuthorizedChannel.child_spec/1","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_event/3 .","ref":"LiveState.Test.AuthorizedChannel.html#handle_event/3","title":"LiveState.Test.AuthorizedChannel.handle_event/3","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_event/4 .","ref":"LiveState.Test.AuthorizedChannel.html#handle_event/4","title":"LiveState.Test.AuthorizedChannel.handle_event/4","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.handle_in/3 .","ref":"LiveState.Test.AuthorizedChannel.html#handle_in/3","title":"LiveState.Test.AuthorizedChannel.handle_in/3","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.handle_info/2 .","ref":"LiveState.Test.AuthorizedChannel.html#handle_info/2","title":"LiveState.Test.AuthorizedChannel.handle_info/2","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_message/2 .","ref":"LiveState.Test.AuthorizedChannel.html#handle_message/2","title":"LiveState.Test.AuthorizedChannel.handle_message/2","type":"function"},{"doc":"Callback implementation for LiveState.Channel.init/3 .","ref":"LiveState.Test.AuthorizedChannel.html#init/3","title":"LiveState.Test.AuthorizedChannel.init/3","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.join/3 .","ref":"LiveState.Test.AuthorizedChannel.html#join/3","title":"LiveState.Test.AuthorizedChannel.join/3","type":"function"},{"doc":"","ref":"LiveState.Test.AuthorizedChannel.html#start_link/1","title":"LiveState.Test.AuthorizedChannel.start_link/1","type":"function"},{"doc":"Callback implementation for LiveState.Channel.state_key/0 .","ref":"LiveState.Test.AuthorizedChannel.html#state_key/0","title":"LiveState.Test.AuthorizedChannel.state_key/0","type":"function"},{"doc":"Callback implementation for LiveState.Channel.state_version_key/0 .","ref":"LiveState.Test.AuthorizedChannel.html#state_version_key/0","title":"LiveState.Test.AuthorizedChannel.state_version_key/0","type":"function"},{"doc":"","ref":"LiveState.Test.Endpoint.html","title":"LiveState.Test.Endpoint","type":"module"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast!/3 .","ref":"LiveState.Test.Endpoint.html#broadcast!/3","title":"LiveState.Test.Endpoint.broadcast!/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast/3 .","ref":"LiveState.Test.Endpoint.html#broadcast/3","title":"LiveState.Test.Endpoint.broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from!/4 .","ref":"LiveState.Test.Endpoint.html#broadcast_from!/4","title":"LiveState.Test.Endpoint.broadcast_from!/4","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from/4 .","ref":"LiveState.Test.Endpoint.html#broadcast_from/4","title":"LiveState.Test.Endpoint.broadcast_from/4","type":"function"},{"doc":"Callback implementation for Plug.call/2 .","ref":"LiveState.Test.Endpoint.html#call/2","title":"LiveState.Test.Endpoint.call/2","type":"function"},{"doc":"Returns the child specification to start the endpoint under a supervision tree.","ref":"LiveState.Test.Endpoint.html#child_spec/1","title":"LiveState.Test.Endpoint.child_spec/1","type":"function"},{"doc":"","ref":"LiveState.Test.Endpoint.html#config/1","title":"LiveState.Test.Endpoint.config/1","type":"function"},{"doc":"Returns the endpoint configuration for key Returns default if the key does not exist.","ref":"LiveState.Test.Endpoint.html#config/2","title":"LiveState.Test.Endpoint.config/2","type":"function"},{"doc":"Reloads the configuration given the application environment changes.","ref":"LiveState.Test.Endpoint.html#config_change/2","title":"LiveState.Test.Endpoint.config_change/2","type":"function"},{"doc":"Returns the host for the given endpoint.","ref":"LiveState.Test.Endpoint.html#host/0","title":"LiveState.Test.Endpoint.host/0","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"LiveState.Test.Endpoint.html#init/1","title":"LiveState.Test.Endpoint.init/1","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast/3 .","ref":"LiveState.Test.Endpoint.html#local_broadcast/3","title":"LiveState.Test.Endpoint.local_broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast_from/4 .","ref":"LiveState.Test.Endpoint.html#local_broadcast_from/4","title":"LiveState.Test.Endpoint.local_broadcast_from/4","type":"function"},{"doc":"Generates the path information when routing to this endpoint.","ref":"LiveState.Test.Endpoint.html#path/1","title":"LiveState.Test.Endpoint.path/1","type":"function"},{"doc":"Generates the script name.","ref":"LiveState.Test.Endpoint.html#script_name/0","title":"LiveState.Test.Endpoint.script_name/0","type":"function"},{"doc":"Starts the endpoint supervision tree. Options :log_access_url - if the access url should be logged once the endpoint starts All other options are merged into the endpoint configuration.","ref":"LiveState.Test.Endpoint.html#start_link/1","title":"LiveState.Test.Endpoint.start_link/1","type":"function"},{"doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file in priv/static . Meant to be used for Subresource Integrity with CDNs.","ref":"LiveState.Test.Endpoint.html#static_integrity/1","title":"LiveState.Test.Endpoint.static_integrity/1","type":"function"},{"doc":"Returns a two item tuple with the first item being the static_path and the second item being the static_integrity .","ref":"LiveState.Test.Endpoint.html#static_lookup/1","title":"LiveState.Test.Endpoint.static_lookup/1","type":"function"},{"doc":"Generates a route to a static file in priv/static .","ref":"LiveState.Test.Endpoint.html#static_path/1","title":"LiveState.Test.Endpoint.static_path/1","type":"function"},{"doc":"Generates the static URL without any path information. It uses the configuration under :static_url to generate such. It falls back to :url if :static_url is not set.","ref":"LiveState.Test.Endpoint.html#static_url/0","title":"LiveState.Test.Endpoint.static_url/0","type":"function"},{"doc":"Generates the endpoint base URL but as a URI struct. It uses the configuration under :url to generate such. Useful for manipulating the URL data and passing it to URL helpers.","ref":"LiveState.Test.Endpoint.html#struct_url/0","title":"LiveState.Test.Endpoint.struct_url/0","type":"function"},{"doc":"","ref":"LiveState.Test.Endpoint.html#subscribe/2","title":"LiveState.Test.Endpoint.subscribe/2","type":"function"},{"doc":"","ref":"LiveState.Test.Endpoint.html#unsubscribe/1","title":"LiveState.Test.Endpoint.unsubscribe/1","type":"function"},{"doc":"Generates the endpoint base URL without any path information. It uses the configuration under :url to generate such.","ref":"LiveState.Test.Endpoint.html#url/0","title":"LiveState.Test.Endpoint.url/0","type":"function"},{"doc":"","ref":"LiveState.Test.PatchChannel.html","title":"LiveState.Test.PatchChannel","type":"module"},{"doc":"Callback implementation for LiveState.Channel.authorize/3 .","ref":"LiveState.Test.PatchChannel.html#authorize/3","title":"LiveState.Test.PatchChannel.authorize/3","type":"function"},{"doc":"","ref":"LiveState.Test.PatchChannel.html#child_spec/1","title":"LiveState.Test.PatchChannel.child_spec/1","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_event/3 .","ref":"LiveState.Test.PatchChannel.html#handle_event/3","title":"LiveState.Test.PatchChannel.handle_event/3","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_event/4 .","ref":"LiveState.Test.PatchChannel.html#handle_event/4","title":"LiveState.Test.PatchChannel.handle_event/4","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.handle_in/3 .","ref":"LiveState.Test.PatchChannel.html#handle_in/3","title":"LiveState.Test.PatchChannel.handle_in/3","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.handle_info/2 .","ref":"LiveState.Test.PatchChannel.html#handle_info/2","title":"LiveState.Test.PatchChannel.handle_info/2","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_message/2 .","ref":"LiveState.Test.PatchChannel.html#handle_message/2","title":"LiveState.Test.PatchChannel.handle_message/2","type":"function"},{"doc":"Callback implementation for LiveState.Channel.init/3 .","ref":"LiveState.Test.PatchChannel.html#init/3","title":"LiveState.Test.PatchChannel.init/3","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.join/3 .","ref":"LiveState.Test.PatchChannel.html#join/3","title":"LiveState.Test.PatchChannel.join/3","type":"function"},{"doc":"","ref":"LiveState.Test.PatchChannel.html#start_link/1","title":"LiveState.Test.PatchChannel.start_link/1","type":"function"},{"doc":"Callback implementation for LiveState.Channel.state_key/0 .","ref":"LiveState.Test.PatchChannel.html#state_key/0","title":"LiveState.Test.PatchChannel.state_key/0","type":"function"},{"doc":"Callback implementation for LiveState.Channel.state_version_key/0 .","ref":"LiveState.Test.PatchChannel.html#state_version_key/0","title":"LiveState.Test.PatchChannel.state_version_key/0","type":"function"},{"doc":"","ref":"LiveState.Test.SocketyChannel.html","title":"LiveState.Test.SocketyChannel","type":"module"},{"doc":"Callback implementation for LiveState.Channel.authorize/3 .","ref":"LiveState.Test.SocketyChannel.html#authorize/3","title":"LiveState.Test.SocketyChannel.authorize/3","type":"function"},{"doc":"","ref":"LiveState.Test.SocketyChannel.html#child_spec/1","title":"LiveState.Test.SocketyChannel.child_spec/1","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_event/3 .","ref":"LiveState.Test.SocketyChannel.html#handle_event/3","title":"LiveState.Test.SocketyChannel.handle_event/3","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_event/4 .","ref":"LiveState.Test.SocketyChannel.html#handle_event/4","title":"LiveState.Test.SocketyChannel.handle_event/4","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.handle_in/3 .","ref":"LiveState.Test.SocketyChannel.html#handle_in/3","title":"LiveState.Test.SocketyChannel.handle_in/3","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.handle_info/2 .","ref":"LiveState.Test.SocketyChannel.html#handle_info/2","title":"LiveState.Test.SocketyChannel.handle_info/2","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_message/2 .","ref":"LiveState.Test.SocketyChannel.html#handle_message/2","title":"LiveState.Test.SocketyChannel.handle_message/2","type":"function"},{"doc":"Callback implementation for LiveState.Channel.init/3 .","ref":"LiveState.Test.SocketyChannel.html#init/3","title":"LiveState.Test.SocketyChannel.init/3","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.join/3 .","ref":"LiveState.Test.SocketyChannel.html#join/3","title":"LiveState.Test.SocketyChannel.join/3","type":"function"},{"doc":"","ref":"LiveState.Test.SocketyChannel.html#start_link/1","title":"LiveState.Test.SocketyChannel.start_link/1","type":"function"},{"doc":"Callback implementation for LiveState.Channel.state_key/0 .","ref":"LiveState.Test.SocketyChannel.html#state_key/0","title":"LiveState.Test.SocketyChannel.state_key/0","type":"function"},{"doc":"Callback implementation for LiveState.Channel.state_version_key/0 .","ref":"LiveState.Test.SocketyChannel.html#state_version_key/0","title":"LiveState.Test.SocketyChannel.state_version_key/0","type":"function"},{"doc":"","ref":"LiveState.Test.TodoChannel.html","title":"LiveState.Test.TodoChannel","type":"module"},{"doc":"Callback implementation for LiveState.Channel.authorize/3 .","ref":"LiveState.Test.TodoChannel.html#authorize/3","title":"LiveState.Test.TodoChannel.authorize/3","type":"function"},{"doc":"","ref":"LiveState.Test.TodoChannel.html#child_spec/1","title":"LiveState.Test.TodoChannel.child_spec/1","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_event/3 .","ref":"LiveState.Test.TodoChannel.html#handle_event/3","title":"LiveState.Test.TodoChannel.handle_event/3","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_event/4 .","ref":"LiveState.Test.TodoChannel.html#handle_event/4","title":"LiveState.Test.TodoChannel.handle_event/4","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.handle_in/3 .","ref":"LiveState.Test.TodoChannel.html#handle_in/3","title":"LiveState.Test.TodoChannel.handle_in/3","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.handle_info/2 .","ref":"LiveState.Test.TodoChannel.html#handle_info/2","title":"LiveState.Test.TodoChannel.handle_info/2","type":"function"},{"doc":"Callback implementation for LiveState.Channel.handle_message/2 .","ref":"LiveState.Test.TodoChannel.html#handle_message/2","title":"LiveState.Test.TodoChannel.handle_message/2","type":"function"},{"doc":"Callback implementation for LiveState.Channel.init/3 .","ref":"LiveState.Test.TodoChannel.html#init/3","title":"LiveState.Test.TodoChannel.init/3","type":"function"},{"doc":"Callback implementation for Phoenix.Channel.join/3 .","ref":"LiveState.Test.TodoChannel.html#join/3","title":"LiveState.Test.TodoChannel.join/3","type":"function"},{"doc":"","ref":"LiveState.Test.TodoChannel.html#start_link/1","title":"LiveState.Test.TodoChannel.start_link/1","type":"function"},{"doc":"Callback implementation for LiveState.Channel.state_key/0 .","ref":"LiveState.Test.TodoChannel.html#state_key/0","title":"LiveState.Test.TodoChannel.state_key/0","type":"function"},{"doc":"Callback implementation for LiveState.Channel.state_version_key/0 .","ref":"LiveState.Test.TodoChannel.html#state_version_key/0","title":"LiveState.Test.TodoChannel.state_version_key/0","type":"function"},{"doc":"","ref":"LiveState.Test.UserSocket.html","title":"LiveState.Test.UserSocket","type":"module"},{"doc":"","ref":"LiveState.Test.Web.html","title":"LiveState.Test.Web","type":"module"},{"doc":"","ref":"LiveState.Test.Web.html#channel/0","title":"LiveState.Test.Web.channel/0","type":"function"}]